Skip to content
Back to top
View this page

# pip lock

## Usage

Unix/macOS

    python -m pip lock [options] [-e] <local project path> ...
    python -m pip lock [options] <requirement specifier> [package-index-options] ...
    python -m pip lock [options] -r <requirements file> [package-index-options] ...
    python -m pip lock [options] <archive url/path> ...

Windows

    py -m pip lock [options] [-e] <local project path> ...
    py -m pip lock [options] <requirement specifier> [package-index-options] ...
    py -m pip lock [options] -r <requirements file> [package-index-options] ...
    py -m pip lock [options] <archive url/path> ...

## Description

EXPERIMENTAL - Lock packages and their dependencies from:

- PyPI (and other indexes) using requirement specifiers.

- VCS project urls.

- Local project directories.

- Local or remote source archives.

pip also supports locking from “requirements files”, which provide an easy way to specify a whole environment to be installed.

The generated lock file is only guaranteed to be valid for the current python version and platform.

## Options

-o, --output <path>

  Lock file name (default=pylock.toml). Use - for stdout.

  (environment variable: `PIP_OUTPUT`)

-r, --requirement <file>

  Install from the given requirements file. The file or URL can be in pip’s requirements.txt format, or pylock.toml format. pylock.toml support is experimental. This option can be used multiple times.

  (environment variable: `PIP_REQUIREMENT`)

--requirements-from-script <file>

  Install dependencies of the given script file as defined by PEP 723 inline metadata.

  (environment variable: `PIP_REQUIREMENTS_FROM_SCRIPT`)

-c, --constraint <file>

  Constrain versions using the given constraints file. This option can be used multiple times.

  (environment variable: `PIP_CONSTRAINT`)

--build-constraint <file>

  Constrain build dependencies using the given constraints file. This option can be used multiple times.

  (environment variable: `PIP_BUILD_CONSTRAINT`)

--no-deps

  Don’t install package dependencies.

  (environment variable: `PIP_NO_DEPS`, `PIP_NO_DEPENDENCIES`)

-e, --editable <path/url>

  Install a project in editable mode (i.e. setuptools “develop mode”) from a local project path or a VCS url.

  (environment variable: `PIP_EDITABLE`)

--src <dir>

  Directory to check out editable projects into. The default in a virtualenv is “<venv path>/src”. The default for global installs is “<current dir>/src”.

  (environment variable: `PIP_SRC`, `PIP_SOURCE`, `PIP_SOURCE_DIR`, `PIP_SOURCE_DIRECTORY`)

--ignore-requires-python

  Ignore the Requires-Python information.

  (environment variable: `PIP_IGNORE_REQUIRES_PYTHON`)

--no-build-isolation

  Disable isolation when building a modern source distribution. Build dependencies specified by PEP 518 must be already installed if this option is used.

  (environment variable: `PIP_NO_BUILD_ISOLATION`)

--check-build-dependencies

  Check the build dependencies.

  (environment variable: `PIP_CHECK_BUILD_DEPENDENCIES`)

-C, --config-settings <settings>

  Configuration settings to be passed to the build backend. Settings take the form KEY=VALUE. Use multiple --config-settings options to pass multiple keys to the backend.

  (environment variable: `PIP_CONFIG_SETTINGS`)

--require-hashes

  Require a hash to check each requirement against, for repeatable installs. This option is implied when any package in a requirements file has a --hash option.

  (environment variable: `PIP_REQUIRE_HASHES`)

--progress-bar <progress_bar>

  Specify whether the progress bar should be used. In ‘auto’ mode, --quiet will suppress all progress bars. [auto, on, off, raw] (default: auto)

  (environment variable: `PIP_PROGRESS_BAR`)

--group <[path:]group>

  Install a named dependency-group from a “pyproject.toml” file. If a path is given, the name of the file must be “pyproject.toml”. Defaults to using “pyproject.toml” in the current directory.

  (environment variable: `PIP_GROUP`)

--no-clean

  Don’t clean up build directories.

  (environment variable: `PIP_NO_CLEAN`)

-i, --index-url <url>

  Base URL of the Python Package Index (default https://pypi.org/simple). This should point to a repository compliant with PEP 503 (the simple repository API) or a local directory laid out in the same format.

  (environment variable: `PIP_INDEX_URL`, `PIP_PYPI_URL`)

--extra-index-url <url>

  Extra URLs of package indexes to use in addition to --index-url. Should follow the same rules as --index-url.

  (environment variable: `PIP_EXTRA_INDEX_URL`)

--no-index

  Ignore package index (only looking at --find-links URLs instead).

  (environment variable: `PIP_NO_INDEX`)

-f, --find-links <url>

  If a URL or path to an html file, then parse for links to archives such as sdist (.tar.gz) or wheel (.whl) files. If a local path or file:// URL that’s a directory, then look for archives in the directory listing. Links to VCS project URLs are not supported.

  (environment variable: `PIP_FIND_LINKS`)

--uploaded-prior-to <datetime_or_duration>

  Only consider packages uploaded prior to the given value. Accepts an ISO 8601 datetime (e.g., ‘2023-01-01T00:00:00Z’, uses local timezone if none specified) or a duration in days (e.g., ‘P3D’ for packages uploaded at least 3 days ago). Only effective when installing from indexes that provide upload-time metadata.

  (environment variable: `PIP_UPLOADED_PRIOR_TO`)

--pre

  Include pre-release and development versions. By default, pip only finds stable versions.

  (environment variable: `PIP_PRE`)

--all-releases <release_control>

  Allow all release types (including pre-releases) for a package. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to allow pre-releases for all packages, “:none:” to empty the set (notice the colons), or one or more package names with commas between them (no colons). Cannot be used with --pre.

  (environment variable: `PIP_ALL_RELEASES`)

--only-final <release_control>

  Only allow final releases (no pre-releases) for a package. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to disable pre-releases for all packages, “:none:” to empty the set, or one or more package names with commas between them. Cannot be used with --pre.

  (environment variable: `PIP_ONLY_FINAL`)

--no-binary <format_control>

  Do not use binary packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to disable all binary packages, “:none:” to empty the set (notice the colons), or one or more package names with commas between them (no colons). Note that some packages are tricky to compile and may fail to install when this option is used on them.

  (environment variable: `PIP_NO_BINARY`)

--only-binary <format_control>

  Do not use source packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to disable all source packages, “:none:” to empty the set, or one or more package names with commas between them. Packages without binary distributions will fail to install when this option is used on them.

  (environment variable: `PIP_ONLY_BINARY`)

--prefer-binary

  Prefer binary packages over source packages, even if the source packages are newer.

  (environment variable: `PIP_PREFER_BINARY`)

## Examples

1. Emit a `pylock.toml` for the project in the current directory

   Unix/macOS

       python -m pip lock -e .

   Windows

       py -m pip lock -e .